/* $Id: eventque.c 1.1 1994/01/26 19:02:45 ulrich Exp $ */
/*
 * eventque.c
 *
 * Event Queue functions, source code partly from GRX 1.03 mouse.c.
 */
#include "Xlibemu.h"

#include <grx20.h>

#include <string.h>
#include <stdarg.h>

#ifdef __TURBOC__
# include <time.h>
# include <conio.h>
#endif

#if defined ( __CYGWIN32__ )
#include <time.h>
#elif defined ( __GNUC__ )
  extern  long	    rawclock();
# define  clock()   rawclock()
#endif

/*
 * queue status flags
 */

static int kb_enable	= TRUE;
static int ms_enable	= TRUE;
static int ms_buttons;

static char ptr12x16bits[] = {
    0,1,0,0,0,0,0,0,0,0,0,0,
    1,2,1,0,0,0,0,0,0,0,0,0,
    1,2,2,1,0,0,0,0,0,0,0,0,
    1,2,2,2,1,0,0,0,0,0,0,0,
    1,2,2,2,2,1,0,0,0,0,0,0,
    1,2,2,2,2,2,1,0,0,0,0,0,
    1,2,2,2,2,2,2,1,0,0,0,0,
    1,2,2,2,2,2,2,2,1,0,0,0,
    1,2,2,2,2,2,2,2,2,1,0,0,
    1,2,2,2,2,2,2,2,2,2,1,0,
    1,2,2,2,2,2,2,2,2,2,2,1,
    1,2,2,2,2,1,1,1,1,1,1,0,
    1,2,2,2,1,0,0,0,0,0,0,0,
    1,2,2,1,0,0,0,0,0,0,0,0,
    1,2,1,0,0,0,0,0,0,0,0,0,
    0,1,0,0,0,0,0,0,0,0,0,0,
};

void _WQueueUnInit(void)
{
	GrMouseUnInit();
}

void _WQueueInit(void)
{
	GrMouseEventMode(1);
	GrMouseInit();
}

void _WMouseSetSpeed(int speed)
{
	GrMouseSetSpeed(speed,1);
}

void _WMouseSetAccel(int thresh,int accel)
{
	GrMouseSetAccel(thresh,accel);
}

void _WMouseSetLimits(int x1,int y1,int x2,int y2)
{
	GrMouseSetLimits(x1,y1,x2,y2);
}

void _WMouseGetLimits(int *x1,int *y1,int *x2,int *y2)
{
	GrMouseGetLimits(x1,y1,x2,y2);
}

void _WMouseWarp(int x,int y)
{
	GrMouseWarp(x,y);
}

void _WMouseSetCursor(GrCursor *cursor)
{
	GrMouseSetCursor(cursor);
}

void _WMouseSetColors(long fg,long bg)
{
	GrMouseSetColors(fg,bg);
}

void _WMouseDisplayCursor(void)
{
  GrMouseDisplayCursor(); 
}

void _WMouseEraseCursor(void)
{
	GrMouseEraseCursor();
}

int _WMouseBlock(GrContext *c,int x1,int y1,int x2,int y2)
{
	int retval;

	GrMouseBlock(c,x1,y1,x2,y2);
	return(retval);
}

void _WMouseUnBlock(int flags)
{
	GrMouseUnBlock(flags);
}

void _WMouseEventEnable(int enable_kb,int enable_ms)
{
	GrMouseEventEnable(enable_kb,enable_ms);
	kb_enable = enable_kb;
	ms_enable = enable_ms;
}

void _WQueueGetEvent(int flags,_WQueueEvent *e)
{
	if(!kb_enable) flags &= ~GR_M_KEYPRESS;
	if(!ms_enable) flags &= ~(GR_M_MOTION | GR_M_BUTTON_DOWN | GR_M_BUTTON_UP);
	if(!(flags & GR_M_EVENT)) { e->flags = 0; return; }

	GrMouseGetEventT(flags,(GrMouseEvent *)e,0L);
	//  printf("%c ",e->key);
        // printf("------- key: %c \n", e->key);
	ms_buttons = e->buttons;
}

int _WQueuePendingEvent(void)
{
	return GrMousePendingEvent();
}

void _WQueueQuery (_WQueueEvent *e)
{
  e->flags	= 0;
  e->x		= GrMouseInfo->xpos;
  e->y		= GrMouseInfo->ypos;
  e->buttons = ms_buttons;
  e->key	= GrMouseInfo->queue->key;
  e->scan	= 0;
  e->kbstat	= GrMouseInfo->queue->kbstat;
  e->time	= clock();

}
