/* $Id: hello.c 1.1 1994/01/12 04:36:59 ulrich Exp $ */
/*
 * hello.c
 *
 * Say "Hello, World." demo program.
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>

#include <X11/bitmaps/stipple>

extern char *config_file;
char hello[] = "Hello, World.";
char hi[] = "Hi!";


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef  __GNUC__
extern  int getch(void);
extern  int kbhit(void);
#endif

#include "grx20.h"
#include "grxkeys.h"
//#include "drawing.h"

extern void (*testfunc)(void);
char   exit_message[2000] = { "" };
int    Argc;
char **Argv;

int GRXMain (int argc,char **argv)
{
	int  x = 0;
	int  y = 0;
	long c = 0;

#ifdef NEVER
	Argc = argc - 1;
	Argv = argv + 1;
	if((Argc >= 2) &&
	   (sscanf(Argv[0],"%d",&x) == 1) && (x >= 320) &&
	   (sscanf(Argv[1],"%d",&y) == 1) && (y >= 200)) {
		Argc -= 2;
		Argv += 2;
		if (Argc > 0) {
		   char *endp;
		   c = strtol(Argv[0], &endp, 0);
		   switch (*endp) {
		     case 'k':
		     case 'K': c <<= 10; break;
		     case 'm':
		     case 'M': c <<= 20; break;
		   }
		   Argc--;
		   Argv++;
		}
	}
	if(c >= 2)
		GrSetMode(GR_width_height_color_graphics,x,y,c);
	else if((x >= 320) && (y >= 200))
		GrSetMode(GR_width_height_graphics,x,y);
	else GrSetMode(GR_default_graphics);
        GrMouseDisplayCursor();
	Hello(Argc, Argv);
	GrSetMode(GR_default_text);
	if(strlen(exit_message) > 0) {
		puts(exit_message);
		getch();
	}
	return(0);
#endif

//    GrSetMode(GR_default_graphics);
//    GrMouseDisplayCursor();
//    fvwm();
	Hello(Argc, Argv);
//	GrSetMode(GR_default_text);
   
	return(0);

}


int
//GRXMain (int argc, char *argv[])
Hello (int argc,char **argv)
{
  Display *mydisplay;
  Window   mywindow;
  GC mygc;
  XGCValues mygcvalues;
  XEvent myevent;
  KeySym mykey;
  XSizeHints myhint;
  int myscreen;
  unsigned long myforeground, mybackground;
  int i;
  char text[10];
  int done;
  XColor red;
  Cursor mycursor;
  Pixmap mypixmap;
  
  mydisplay = XOpenDisplay ("");
  myscreen = DefaultScreen (mydisplay);
  mybackground = WhitePixel (mydisplay, myscreen);
  myforeground = BlackPixel (mydisplay, myscreen);
  
//  myhint.x = 200; myhint.y = 300;
  myhint.x = 100; myhint.y = 150;
  myhint.width = 350; myhint.height = 250;
  myhint.flags = PPosition|PSize;

  mywindow = XCreateSimpleWindow (mydisplay,
				  DefaultRootWindow (mydisplay),
				  myhint.x, myhint.y, myhint.width, myhint.height,
				  5, myforeground, mybackground);
  XSetStandardProperties (mydisplay, mywindow, hello, hello,
			  None, argv, argc, &myhint);

  mycursor = XCreateFontCursor (mydisplay, XC_left_ptr);
  XDefineCursor (mydisplay, mywindow, mycursor);

  mygc = XCreateGC (mydisplay, mywindow, 0, 0);
  mypixmap = XCreateBitmapFromData (mydisplay, mywindow, 
				    stipple_bits, stipple_width, stipple_height);

  mygcvalues.foreground = myforeground;
  mygcvalues.background = mybackground;
  mygcvalues.fill_style = FillStippled;
  mygcvalues.stipple = mypixmap;
  XChangeGC (mydisplay, mygc,
	     GCForeground | GCBackground | GCFillStyle | GCStipple, &mygcvalues);

  XAllocNamedColor (mydisplay,
		    DefaultColormap (mydisplay, myscreen),
		    "red", &red, &red);

  XSelectInput (mydisplay, mywindow,
		ButtonPressMask
		| KeyPressMask
		| ExposureMask
		| EnterWindowMask
		| LeaveWindowMask);

  XMapRaised (mydisplay, mywindow);

  done = 0;
  while (done == 0) {
    //fvwm();

   if (!XPending(mydisplay)) continue;

    XNextEvent (mydisplay, &myevent);

#ifdef DEBUG
    _XPrintEvent (mydisplay, &myevent);
#endif

    switch (myevent.type) 
      {
      case Expose:
	if (myevent.xexpose.count == 0)
	  XDrawImageString (myevent.xexpose.display,
			    myevent.xexpose.window,
			    mygc,
			    100, 100,
			    hello, strlen (hello));
	break;

      case ButtonPress:
                             
	XDrawImageString (myevent.xbutton.display,
			  myevent.xbutton.window,
			  mygc,
			  myevent.xbutton.x, myevent.xbutton.y,
			  hi, strlen (hi));
	break;
	
      case KeyPress:
	i = XLookupString (&myevent.xkey, text, 10, &mykey, 0);
	if (i == 1 && text[0] == 'q') done = 1;
	break;

      case EnterNotify:
	XSetWindowBorder (mydisplay, myevent.xcrossing.window, red.pixel);
	break;

      case LeaveNotify:
	XSetWindowBorder (mydisplay, myevent.xcrossing.window, myforeground);
	break;
      }
  }
  XFreeGC (mydisplay, mygc);
  XDestroyWindow (mydisplay, mywindow);
#ifdef DEBUG
  _XPrintTree (mydisplay, DefaultRootWindow (mydisplay), 0);
#endif
  XCloseDisplay (mydisplay);
  exit (0);
}
